Static Public Member Functions

# BinNavi.API.debug.BreakpointHelpers Class Reference

Offers convenience functions for working with breakpoints. More...

List of all members.

## Static Public Member Functions
static List< Address > | getBreakpoints (final Debugger debugger, final CodeNode node)
| Finds breakpoints set in a code node.
static List< Address > | getBreakpoints (final Debugger debugger, final View view)
| Finds breakpoints set in a view.
static List< Address > | getEchoBreakpoints (final Debugger debugger, final CodeNode node)
| Finds echo breakpoints set in a code node.
static List< Address > | getEchoBreakpoints (final Debugger debugger, final View view)
| Finds echo breakpoints set in a view.

## Detailed Description

Offers convenience functions for working with breakpoints. Please note that many convenience functions are just straight-forward implementations of commonly used algorithms and therefore can have significant runtime costs.

## Member Function Documentation

static List<Address> BinNavi.API.debug.BreakpointHelpers.getBreakpoints | ( | final Debugger | debugger,
|  | final CodeNode | node |
| ) |  |  | `[static]`

Returns the addresses of all breakpoints set in a given code node.

This function is guaranteed to run in O(n) where n is the number of instructions in the breakpoint.

Parameters:

  | debugger | Debugger that is checked for set breakpoints.
  | node | The code node that is checked for set breakpoints.

Returns:
  A list of addresses where breakpoints are set inside the code node.

static List<Address> BinNavi.API.debug.BreakpointHelpers.getBreakpoints | ( | final Debugger | debugger,
|  | final View | view |
| ) |  |  | `[static]`

Returns the addresses of all breakpoints set in a given view. This includes breakpoints set in code nodes and breakpoints set in function nodes.

This function is guaranteed to run in O(m + n) where m is the number of function nodes in the view and n is the number of instructions in the view.

Parameters:

  | debugger | Debugger that is checked for set breakpoints.
  | view | The view that is checked for set breakpoints.

Returns:
  A list of addresses where breakpoints are set inside the view.

static List<Address> BinNavi.API.debug.BreakpointHelpers.getEchoBreakpoints | ( | final Debugger | debugger,
|  | final CodeNode | node |
| ) |  |  | `[static]`

Returns the addresses of all echo breakpoints set in a given code node.

This function is guaranteed to run in O(n) where n is the number of instructions in the breakpoint.

Parameters:

  | debugger | Debugger that is checked for set echo breakpoints.
  | node | The code node that is checked for set echo breakpoints.

Returns:
  A list of addresses echo where breakpoints are set inside the code node.

static List<Address> BinNavi.API.debug.BreakpointHelpers.getEchoBreakpoints | ( | final Debugger | debugger,
|  | final View | view |
| ) |  |  | `[static]`

Returns the addresses of all echo breakpoints set in a given view. This includes echo breakpoints set in code nodes and echo breakpoints set in function nodes.

This function is guaranteed to run in O(m + n) where m is the number of function nodes in the view and n is the number of instructions in the view.

Parameters:

  | debugger | Debugger that is checked for set echo breakpoints.
  | view | The view that is checked for set echo breakpoints.

Returns:
  A list of addresses where echo breakpoints are set inside the view.